// original javascript modified by Ib Harmsen to read a settings.ini file (and other changes)
// modified 2010-07 to handle local file.  IH

var file = "";
var pwsname = "";				    // added by Andreovia
var temperature2 = "";
var sitename = 0;
var usdate = "";

// is debugging ?
var dbg = new ActiveXObject("Scripting.FileSystemObject");
var bDebug = dbg.FileExists(System.Gadget.path+"\\debug.txt");

var ini = new ActiveXObject("Scripting.FileSystemObject");
var bini = ini.FileExists(System.Gadget.path+"\\settings.ini");

/* Development Use ONLY
function debugLog(str) {
    try{
        System.Debug.outputString(str);
        if (bDebug) debugLogFile.WriteLine(str);
    } catch(err) {}
}
*/
// Debuglog
function debugLog(str) 
{
    try
    {
        if (bDebug)
        {
            var oFSO = new ActiveXObject("Scripting.FileSystemObject");
            var iFlag = 2;
            if (str != "")
                iFlag = 8; 
        
            var debugLogFile = oFSO.OpenTextFile(System.Gadget.path+"\\debug.txt", iFlag);
            debugLogFile.WriteLine(new Date().toLocaleString() + ": " + str);
            debugLogFile.Close();
            debugLogFile = null;
        }
    } 
    catch(err) 
    {
    }
}

function onLoad()
{
   debugLog('Settings.js:');
   file = System.Gadget.Settings.read("txtfile");
   pwsname = System.Gadget.Settings.read("pwsname");				    // added by Andreovia
   interval = System.Gadget.Settings.read("interval");
   temperature2 = System.Gadget.Settings.read("temperature2");
   sitename = System.Gadget.Settings.read("sitename");
   usdate = System.Gadget.Settings.read("usdate");
   if (file == "" && interval == "")
   {
     if (bini)
     {
       debugLog('    Settings.ini exists.');
       var fso = new ActiveXObject("Scripting.FileSystemObject");
       var fini = fso.OpenTextFile(System.Gadget.path+"\\settings.ini", 1);
       while (!fini.AtEndOfStream)
       {
          var rec = fini.ReadLine();
          eval(rec);
       }
       fini.Close();
       fini = null;
     }
     else debugLog('    Settings.ini does not exist.');
   }
   if (file == "" || file == "http://") xmlurl.value = 'http://yourcumulus/realtime.txt';
   else xmlurl.value = file;
   if (interval == "") interval = 10;
   reftime.value = interval;
   debugLog('   file: ' + file + ', interval: ' + interval + ', temperature2: ' + temperature2 + ', sitename: ' + sitename + ', usdate: ' + usdate);
   System.Gadget.onSettingsClosing = SettingsClosing;
}

function SettingsClosing(event)
{
   debugLog('  SettingsClosing:');
    // Save the settings if the user clicked OK.
    if (event.closeAction == event.Action.commit)
    {
      document.getElementById('xmlerror').innerHTML = '';
      document.getElementById('numerror').innerHTML = '';
      var url = xmlurl.value;
      var num = reftime.value;
      debugLog('    OK was clicked. url: ' + url);
      isxml = checkXML(url);
      debugLog('   url: ' + url + ' isxml: ' + isxml);
      isnum = checkRefresh(num);

      if(isxml && isnum)
      {
         txtfile = xmlurl.value;
         interval = reftime.value
         debugLog('    setting interval: ' + interval);
         System.Gadget.Settings.write("txtfile", txtfile);
         System.Gadget.Settings.write("pwsname", pwsname);				    // added by Andreovia
         System.Gadget.Settings.write("interval", interval);
         System.Gadget.Settings.write("temperature2", temperature2);
         System.Gadget.Settings.write("sitename", sitename);
         System.Gadget.Settings.write("usdate", usdate);
      }
      else
      {
         if(!isxml)
         {
             document.getElementById('xmlerror').innerHTML = 'realtime.txt not found';
         }
         if(!isnum)
         {
            document.getElementById('numerror').innerHTML = 'Must be an integer';
         }
         debugLog('   else..' + xmlurl.value);
         event.cancel = true;
         return;
      }
    }
    // Allow the Settings dialog to close.
   event.cancel = false;
   debugLog('    event.cancel - ' + event.cancel);
   debugLog('end settings.js');
}

function checkXML(url)
{
   if (url.substr(0,7) == "http://" || url.substr(0,8) == "https://"  )
   {
     oHttp = new XMLHttpRequest();
     oHttp.open("HEAD", url, false);
     oHttp.send();
     debugLog('    oHttp.status: ' + oHttp.status);
     return (oHttp.status==200) ? true : false;
   }
   else
   {
     debugLog('    not http - assuming local file...');
     var ftxt = new ActiveXObject("Scripting.FileSystemObject");
     var btxt = ftxt.FileExists(url);
     debugLog('    File:' + url + ' btxt:' + btxt);
     return btxt;
   }
}

function checkRefresh(myNum)
{
   return (isNaN(myNum) || (myNum % 1)!=0) ? false : true;
}
